SUBROUTINE VOIGT_TAYLOR(NUMW,DAM,FREC,PHI,PSI)
  !
  ! J M Borrero
  ! Apr 24, 2008
  ! HAO-NCAR for HMI-Stanford
  !
  USE CONS_PARAM
  USE VOIGT_DATA
!  USE LINE_PARAM
  !
  IMPLICIT NONE
  INTEGER(2) :: NUMW
!  REAL(DP),   DIMENSION(NUMW)  :: FREC, PHI, PSI
  REAL(8),DIMENSION(NUMW)  :: FREC
  REAL,   DIMENSION(NUMW)  :: PHI, PSI
  REAL         :: rDAM
  REAL(DP)     :: U, DAM, COEF1, COEF2, COEF3, COEF4, DELTAU !, COEF5, COEF6
  INTEGER      :: I, HERE
  !
  call voigt_init

  rDAM=real(DAM,kind=4)
  DO I=1,NUMW
     U=FREC(I)
     IF (U.LT.0) U=ABS(U)
     !
     IF (U.GE.29.99D0.OR.U.LT.1D0) CALL FVOIGT(1,rDAM,FREC(I),PHI(I),PSI(I))
     IF (U.LT.29.99D0.AND.U.GE.1D0) THEN
        HERE=ANINT(3001D0*U/30D0)
        DELTAU=U-UU(HERE)
        COEF1=HH(HERE)
        COEF2=FF(HERE)
        COEF3=4D0*DAM*COEF2-2D0*U*COEF1
        COEF4=1D0/SQRT(DPI)-2D0*U*COEF2-DAM*COEF1
!        COEF5=4D0*DAM*COEF4-2D0*COEF1-2D0*U*COEF3
!        COEF6=-2D0*COEF2-2D0*U*COEF4-DAM*COEF3
        PSI(I)=COEF2+COEF4*DELTAU!+COEF6*DELTAU**2D0
        PHI(I)=COEF1+COEF3*DELTAU!+COEF5*DELTAU**2D0
        IF (FREC(I).LT.0) PSI(I)=-PSI(I)
     ENDIF 
  ENDDO

END SUBROUTINE VOIGT_TAYLOR
